import { useEffect } from "react";
import { Highlight } from "../utils/Highlight-functions";

export function IntSidebar(){
    let nums = [ "maxH", "olariuH", "joshuaH", "juliaH", "nicoleH", "mattijsH", "westhoffH", "berensH", "wischmeyerH"]
    useEffect(() => {
        window.addEventListener('scroll', handleScroll);
        return () => window.removeEventListener('scroll', handleScroll);
      }, []);
      const handleScroll = () => {
          for(let idx in nums){
            /* console.log("We are looking at 'item' = " + nums[idx]) */
              const item = nums[idx];
              let ind = nums.findIndex((e) => e == item)
             /*  console.log("ind is: " + ind) */
              let subdi = "subtitle" + ind 
              /* console.log("subdi is: " + subdi)
              console.log("we use " +  document.getElementById(item)?.id + " and " + document.getElementById(subdi)?.id) */
              Highlight({el: document.getElementById(item)!}, {subtitle: document.getElementById(subdi)!});
          }       
          /*     */
      }
      /* console.log(nums) */
    return(
        <div className="col-2 d-none d-lg-block">
            <br/>
            <div className="sticky-top">
            <nav className="sidebar">
                <div> 
                    <a onClick={openAndScroll({ it: "tab-max", scrollTarget: "max" })}>
                        <div id="subtitle0" className="detail-sideitem">
                            <div id="parent-max" className="sideitem">
                                <summary>Max</summary>
                            </div>
                        </div>
                    </a>
                </div>
                <div> 
                    <a onClick={openAndScroll({ it: "tab-olariu", scrollTarget: "olariu" })}>
                        <div id="subtitle1" className="detail-sideitem">
                            <div id="parent-olariu" className="sideitem">
                                <summary>Olariu</summary>
                            </div>
                        </div>
                    </a>
                </div>
                <div> 
                    <a onClick={openAndScroll({ it: "tab-joshua", scrollTarget: "joshua" })}>
                        <div id="subtitle2" className="detail-sideitem">
                            <div id="parent-joshua" className="sideitem">
                                <summary>Joshua</summary>
                            </div>
                        </div>
                    </a>
                </div>
                <div> 
                    <a onClick={openAndScroll({ it: "tab-julia", scrollTarget: "julia" })}>
                        <div id="subtitle3" className="detail-sideitem">
                            <div id="parent-julia" className="sideitem">
                                <summary>Julia</summary>
                            </div>
                        </div>
                    </a>
                </div>
                <div> 
                    <a onClick={openAndScroll({ it: "tab-nicole", scrollTarget: "nicole" })}>
                        <div id="subtitle4" className="detail-sideitem">
                            <div id="parent-nicole" className="sideitem">
                                <summary > Nicole </summary>
                            </div>
                        </div>
                    </a>
                </div>
                <div> 
                    <a onClick={openAndScroll({ it: "tab-mattijs", scrollTarget: "mattijs" })}>
                        <div id="subtitle5" className="detail-sideitem">
                            <div id="parent-mattijs" className="sideitem">
                                <summary>mattijs</summary>
                            </div>
                        </div>
                    </a>
                </div>
                <div> 
                    <a onClick={openAndScroll({ it: "tab-westhoff", scrollTarget: "westhoff" })}>
                        <div id="subtitle6" className="detail-sideitem">
                            <div id="parent-westhoff" className="sideitem">
                                <summary>Katrin</summary>
                            </div>
                        </div>
                    </a>
                </div>
                <div> 
                    <a onClick={openAndScroll({ it: "tab-berens", scrollTarget: "berens" })}>
                        <div id="subtitle7" className="detail-sideitem">
                            <div id="parent-berens" className="sideitem">
                                <summary>Berens</summary>
                            </div>
                        </div>
                    </a>
                </div>
                <div> 
                    <a onClick={openAndScroll({ it: "tab-wischmeyer", scrollTarget: "wischmeyer" })}>
                        <div id="subtitle8" className="detail-sideitem">
                            <div id="parent-wischmeyer" className="sideitem">
                                <summary>Wischmeyer</summary>
                            </div>
                        </div>
                    </a>
                </div>
                <div> 
                    <a onClick={openAndScroll({ it: "tab-olariu", scrollTarget: "olariu" })}>
                        <div id="subtitle9" className="detail-sideitem">
                            <div id="parent-olariu" className="sideitem">
                                <summary>Olariu</summary>
                            </div>
                        </div>
                    </a>
                </div>
            </nav>
        </div>
    </div>
    )
}

   

  export function openAndScroll({ it, scrollTarget }: { it: string, scrollTarget?: string }) {
    const gotoandopen = (_event: React.MouseEvent<HTMLElement, MouseEvent>) => {
        _event.preventDefault(); // Prevent default anchor behavior

        console.log(`openAndScroll called with it: ${it} and scrollTarget: ${scrollTarget}`);

        // Attempt to find the elements
        const subtabElement = document.getElementById(it);
        const parentElementId = "parent-" + it.replace("tab-", "");
        const parentElement = document.getElementById(parentElementId);

        console.log(`subtabElement with ID ${it}: `, subtabElement);
        console.log(`parentElement with ID ${parentElementId}: `, parentElement);

        if (subtabElement && parentElement) {
            console.log("Found subtabElement and parentElement.");
            // Show the selected tab in the sidebar and add active class
            subtabElement.style.display = "block";
            parentElement.classList.add("active-sideitem");
        } else {
            console.error(`Subtab element or parent element not found for ID: ${it}`);
        }

        // If a scroll target is provided, scroll to that element on the page
        if (scrollTarget) {
            const targetElement = document.getElementById(scrollTarget);
            if (targetElement) {
                console.log(`Scrolling to element with ID: ${scrollTarget}`);
                
                // Get the position of the element relative to the document
                const elementRect = targetElement.getBoundingClientRect();
                const elementTop = elementRect.top + window.scrollY;
                
                // Calculate the middle of the viewport
                const viewportHeight = window.innerHeight;
                const scrollOffset = elementTop - (viewportHeight / 5 - targetElement.offsetHeight / 2);
               /*  
                console.log(`Element Top: ${elementTop}`);
                console.log(`Viewport Height: ${viewportHeight}`);
                console.log(`Scroll Offset: ${scrollOffset}`); */
                
                window.scrollTo({
                    top: scrollOffset,
                    behavior: "smooth"
                });
            } else {
                console.error(`Scroll target element not found for ID: ${scrollTarget}`);
            }
        }
    }
    return gotoandopen;
}

